Create user agent
curl --request POST \
--url https://neo.api.projectdiscovery.io/api/v1/agents/user \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"agent_id": "<string>",
"name": "<string>",
"system_context": "<string>",
"custom_tools": [
{
"command_template": "<string>",
"description": "<string>",
"id": "<string>",
"input_schema": {},
"is_executable": true,
"script_content": "<string>",
"script_path": "<string>",
"timeout_seconds": 123
}
],
"description": "<string>",
"install_commands": [
"<string>"
],
"is_dynamic": true,
"native_tools": [
"<string>"
],
"prereq_packages": [
"<string>"
],
"require_env_vars": [
"<string>"
],
"tags": [
"<string>"
],
"verify_commands": [
"<string>"
],
"when_to_use": "<string>"
}
'import requests
url = "https://neo.api.projectdiscovery.io/api/v1/agents/user"
payload = {
"agent_id": "<string>",
"name": "<string>",
"system_context": "<string>",
"custom_tools": [
{
"command_template": "<string>",
"description": "<string>",
"id": "<string>",
"input_schema": {},
"is_executable": True,
"script_content": "<string>",
"script_path": "<string>",
"timeout_seconds": 123
}
],
"description": "<string>",
"install_commands": ["<string>"],
"is_dynamic": True,
"native_tools": ["<string>"],
"prereq_packages": ["<string>"],
"require_env_vars": ["<string>"],
"tags": ["<string>"],
"verify_commands": ["<string>"],
"when_to_use": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
agent_id: '<string>',
name: '<string>',
system_context: '<string>',
custom_tools: [
{
command_template: '<string>',
description: '<string>',
id: '<string>',
input_schema: {},
is_executable: true,
script_content: '<string>',
script_path: '<string>',
timeout_seconds: 123
}
],
description: '<string>',
install_commands: ['<string>'],
is_dynamic: true,
native_tools: ['<string>'],
prereq_packages: ['<string>'],
require_env_vars: ['<string>'],
tags: ['<string>'],
verify_commands: ['<string>'],
when_to_use: '<string>'
})
};
fetch('https://neo.api.projectdiscovery.io/api/v1/agents/user', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"description": "<string>",
"has_dynamic_tools": true,
"has_memory": true,
"id": "<string>",
"name": "<string>",
"tools_count": 123,
"type": "user",
"config_hash": "<string>",
"config_version": 123,
"created_at": "2023-11-07T05:31:56Z",
"custom_tools": [
{
"commandTemplate": "<string>",
"description": "<string>",
"id": "<string>",
"inputSchema": {},
"isExecutable": true,
"scriptContent": "<string>",
"scriptPath": "<string>",
"timeoutSeconds": 123
}
],
"custom_tools_count": 123,
"fork_count": 123,
"has_installation_requirements": true,
"install_commands": [
"<string>"
],
"native_tools": [
"<string>"
],
"original_agent_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"original_creator_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"prereq_packages": [
"<string>"
],
"published_at": "2023-11-07T05:31:56Z",
"require_env_vars": [
"<string>"
],
"system_context": "<string>",
"tags": [
"<string>"
],
"updated_at": "2023-11-07T05:31:56Z",
"uuid": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"verify_commands": [
"<string>"
],
"when_to_use": "<string>"
}{
"error": "Bad request",
"code": "user_spending_cap_reached",
"error_id": "<string>",
"kind": "forbidden request",
"message": "<string>"
}{
"error": "Bad request",
"code": "user_spending_cap_reached",
"error_id": "<string>",
"kind": "forbidden request",
"message": "<string>"
}{
"error": "Bad request",
"code": "user_spending_cap_reached",
"error_id": "<string>",
"kind": "forbidden request",
"message": "<string>"
}Agents
Create user agent
Create a new custom agent for the current user. Each user may have up to 50 custom agents.
POST
/
api
/
v1
/
agents
/
user
Create user agent
Authorizations
BearerAuthApiKeyAuth
JWT authentication token
Body
application/json
Unique agent ID (kebab-case)
System prompt for the agent
Show child attributes
Show child attributes
List of native tool IDs to include
When this agent should be triggered
Response
Agent created
Agent ID for user access (use with /agents/user/{agent_id})
Available options:
user Show child attributes
Show child attributes
Directory entry ID
Available options:
public, private, unlisted ⌘I

